APP           = xb
WINVER        = 3.10
APPVER        = 3.10

!include	<win32.mak>

CC            = cl
ALIAS         = runxb
LIBDIR        = lib
DESTDIR       = c:\windows
SPASM         = spasm
OBJS          = $(LIBDIR)\xlib.o xexcept.obj xrun.o xst.o xin.o xma.o xcm.o xgr.o xui.o $(LIBDIR)\xzzz.o
RESOURCES     = xb.rbj
START         = START /W

all:            $(DESTDIR)\$(APP).dll


$(ALIAS).lib: win32.mak $(ALIAS).mak $(ALIAS).def $(OBJS)
                $(implib) -machine:$(CPU) -def:$(ALIAS).def -out:$(ALIAS).lib $(OBJS)

$(DESTDIR)\$(APP).dll: win32.mak $(ALIAS).mak $(ALIAS).def $(ALIAS).lib $(OBJS)
                       $(link) -dll -debug:partial -debugtype:coff -entry:_DllMainCRTStartup$(DLLENTRY) -subsystem:windows,$(WINVER) -version:$(APPVER) -out:$(ALIAS).dll $(OBJS) $(RESOURCES) $(ALIAS).exp $(guilibsdll) wsock32.lib
                       copy $(ALIAS).dll $(DESTDIR)\$(APP).dll
                       copy $(ALIAS).dll \xb\run\$(ALIAS).dll
                       copy $(ALIAS).dll \xb\run\$(APP).dll

xb.rbj:         xb.rc
                rc -i \xb -i \xb\xxx -r -fo xb.res xb.rc
                cvtres -i386 xb.res -o xb.rbj

xexcept.obj:    xexcept.c
                $(CC) -c -W3 -D_X86_=1 -DWIN32 -D_WIN32 -D_DLL -D_MD /Fa /Zl xexcept.c
#                $(CC) -c -W3 -D_X86_=1 -DWIN32 /Fa xexcept.c

$(LIBDIR)\xstart.o:   $(LIBDIR)\xstart.s
                      $(SPASM) $(LIBDIR)\xstart.s

$(LIBDIR)\xlib.o:     $(LIBDIR)\xlib.s
                      $(SPASM) $(LIBDIR)\xlib.s

$(LIBDIR)\xzzz.o:     $(LIBDIR)\xzzz.s
                      $(SPASM) $(LIBDIR)\xzzz.s

xrun.o:         xrun.s
                $(SPASM) xrun.s

xst.o:          xst.s
                $(SPASM) xst.s

xin.o:          xin.s
                $(SPASM) xin.s

xcm.o:          xcm.s
                $(SPASM) xcm.s

xma.o:          xma.s
                $(SPASM) xma.s

xgr.o:          xgr.s
                $(SPASM) xgr.s

xui.o:          xui.s
                $(SPASM) xui.s

xrun.s:         xrun.x
                $(START) xb xrun.x

xst.s:          xst.x
                $(START) xb xst.x -lib

xin.s:          xin.x
                $(START) xb xin.x -lib

xcm.s:          xcm.x
                $(START) xb xcm.x -lib

xma.s:          xma.x
                $(START) xb xma.x -lib

xgr.s:          xgr.x
                $(START) xb xgr.x -lib

xui.s:          xui.x
                $(START) xb xui.x -lib
