//
// #######################
// #####  xexcept.c  #####  Start NT exception handler  v0.0004
// #######################
//
// Max Reason
// Copyright 1995
// Coral Reef Development
// 1295 S. Kihei Rd, Suite 408
// Kihei, Maui, Hawaii  96753  USA
// (808) 875-8758
//
// March GAMMA:  cl386 -c -W3 -D_X86_=1 -DWIN32 /Fa xexcept.c
//
#include <stdio.h>
#include <string.h>
#include <windows.h>
#include <excpt.h>
#include <winnt.h>
#include <float.h>
//
//
extern void PASCAL Xit (int argc, char **argv, char **envp);
extern long PASCAL XitMain (DWORD code, LPEXCEPTION_POINTERS ep);
extern void PASCAL XxxWriteFile (int fileNumber, char *buffer, int bytes, long *bytesWritten, LPOVERLAPPED overlapped);
//
unsigned long i;
char txt[100];
//
//
//
// #########################################
// #####  XxxStartExceptionHandler ()  #####
// #########################################
//
//	xlib.s calls XxxStartExceptionHandler() to start PDE or standalone program.
//
//	XxxStartExceptionHandler():
//    Starts exception handling
//    Calls Xit() to start PDE or standalone program.
//
//		try { Xit() }
//			Xit() starts PDE.  The try statement places PDE in a guarded mode
//			where any exceptions (breakpoints, breaks, FPE, etc) are transfered
//			to the exception filter.
//
//		except ( -- exception filter -- )
//			The exception filter can be a function call.  Calls XitMain() just
//			like UNIX - sends the NT exception code and a pointer to exception
//			information (registers, address, etc).  The return value is:
//
//				EXCEPTION_CONTINUE_SEARCH			= 0
//						PDE never does this.  It says, "I can't handle this
//						exception, try to find someone else who can."
//				EXCEPTION_EXECUTE_HANDLER			= 1
//						PDE never does this.  It says, "Blowback the entire
//						program (the try block) and pass control to the block
//						following this except() statement.
//				EXCEPTION_CONTINUE_EXECUTION	= -1
//						PDE always does this.  NT returns control to the address
//						in the exception information (which XitMain() may change.)
//
//
void PASCAL XxxStartExceptionHandler (argc, argv, envp)
int argc;
char **argv;
char **envp;
{
	_try
		{
			Xit (argc, argv, envp);
		}
	_except( XitMain (GetExceptionCode(), GetExceptionInformation()) )
		{
			/* Exception "Handler":  task blown off */
			sprintf (txt, "\nPDE:  Untrapped exception  0x%08x\n", GetExceptionCode());
			XxxWriteFile (1, txt, strlen(txt), &i, NULL);
		}
//	strcpy (txt, "PDE is gone.\n");
//	XxxWriteFile (1, txt, strlen(txt), &i, NULL);
//	Sleep (2000);
}
